﻿using System.Web.Mvc;
using ThinkGeo.MapSuite;
using ThinkGeo.MapSuite.Layers;
using ThinkGeo.MapSuite.Mvc;
using ThinkGeo.MapSuite.Styles;

namespace Map_Suite_Web_for_MVC_App1.Controllers
{
    public class HomeController : Controller
    {
        // GET: Home
        public ActionResult Index()
        {
            Map map = new Map("Map1",
               new System.Web.UI.WebControls.Unit(800, System.Web.UI.WebControls.UnitType.Pixel),
               new System.Web.UI.WebControls.Unit(600, System.Web.UI.WebControls.UnitType.Pixel));

            map.MapUnit = GeographyUnit.DecimalDegree;

            LayerOverlay layerOverlay = new LayerOverlay();
            ShapeFileFeatureLayer shapeFileLayer = new ShapeFileFeatureLayer(Request.MapPath("~/App_Data/Countries02.shp"));
            shapeFileLayer.ZoomLevelSet.ZoomLevel01.DefaultAreaStyle = WorldStreetsAreaStyles.Military();
            shapeFileLayer.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;
            layerOverlay.Layers.Add(shapeFileLayer);
            map.CustomOverlays.Add(layerOverlay);

            // Add the static layers to the MapEngine
            ShapeFileFeatureLayer labelLayer = new ShapeFileFeatureLayer(Request.MapPath("~/App_Data/LabelPoint.shp"));

            //Set the custom textstyle with the appropriate column names
            ColumnBasedTextStyle columnBasedTextStyle = new ColumnBasedTextStyle("Name", "Size", "Angle", "Color", "Font");
            //Add the custom textstyle to the customStyles collection.
            labelLayer.ZoomLevelSet.ZoomLevel01.CustomStyles.Add(columnBasedTextStyle);
            labelLayer.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;
            layerOverlay.Layers.Add(labelLayer);

            map.CurrentExtent = new ThinkGeo.MapSuite.Shapes.RectangleShape(-14.00, 54.92, 41.10, 29.31);

            return View(map);
        }
    }
}